#include <stdio.h>
#include <time.h>

//------------------------------------------------------------------------------

const char *timeStamp(bool longForm)
{
   const time_t timer = time(NULL);
   static char  formattedTime[26];

   struct tm *tm_ptr = gmtime(&timer);
   int        gmt_dy = tm_ptr->tm_yday;
   int        gmt_hr = tm_ptr->tm_hour;
   int        gmt_mn = tm_ptr->tm_min;

   tm_ptr = localtime(&timer);
   if (gmt_dy > tm_ptr->tm_yday) gmt_hr += 24;

   if (longForm) {
      int n = strftime(formattedTime, sizeof(formattedTime)-1, "%Y-%m-%dT%H:%M:%S", tm_ptr);
      if (gmt_mn > tm_ptr->tm_min) {
         gmt_mn -= 60;
         gmt_hr +=  1;
      }
      sprintf(formattedTime+n, "%+03d:%02d", tm_ptr->tm_hour-gmt_hr, tm_ptr->tm_min-gmt_mn);
   }
   else {
      // Useful when generating time-stamped file names.
      strftime(formattedTime, sizeof(formattedTime)-1, "%Y%m%d%H%M", tm_ptr);
   }

   return formattedTime;
}

//------------------------------------------------------------------------------

int main()
{
   printf("Long  %s\n", timeStamp(true));
   printf("Short %s\n", timeStamp(false));
}
