//------------------------------------------------------------------------------
//--  CAN IO - I/O for CAN-Enabled MegaSquirt                                 --
//--                                                                          --
//--  Copyright (c) 2005, 2006 by Eric Fahlgren & Lance Gardiner              --
//--  All Rights Reserved.                                                    --
//--                                                                          --
//--  This program is free software; you can redistribute it and/or           --
//--  modify it under the terms of the GNU General Public License             --
//--  as published by the Free Software Foundation; either version            --
//--  2 of the License, or (at your option) any later version.                --
//--  See http://www.gnu.org/licenses/gpl.txt                                 --
//------------------------------------------------------------------------------

#ifndef CAN_IO_H
#define CAN_IO_H
//==============================================================================
//== CAN subsystem  ============================================================

#include "ms2def.h"

#define  CAN_EMPTY_SLOT     0
#define  CAN_MS2_DEVICE     1 // MS-II ECU
#define  CAN_ROUTER_DEVICE  2 // MS Router board
#define  CAN_GPIO_DEVICE    3 // MS GPIO board

#define  CAN_N_DEVICES     16

// Error status words:
//    Bits 0-7 are current errors
//    Bits 8-15 are corresponding latched errors
//
#define  XMT_ERR       0x0101
#define  CLR_XMT_ERR   0xFFFE
#define  XMT_TOUT      0x0202
#define  CLR_XMT_TOUT  0xFFFD
#define  RCV_ERR       0x0404
#define  CLR_RCV_ERR   0xFFFB
#define  SYS_ERR       0x0808

//------------------------------------------------------------------------------

void   Can_Init(UINT08 thisBoardId);

UINT08 Can_NeedsReset(void);
void   Can_Send      (void);

#ifndef GCC_BUILD
#  pragma CODE_SEG  NON_BANKED
#endif
INTERRUPT_PROTO(void CanTxIsr(void));
INTERRUPT_PROTO(void CanRxIsr(void));
#ifndef GCC_BUILD
#  pragma CODE_SEG  DEFAULT
#endif

//==============================================================================
#endif
