//------------------------------------------------------------------------------
//--  GPIO - General Purpose I/O for CAN-Enabled MegaSquirt                   --
//--                                                                          --
//--  Copyright (c) 2006 by Eric Fahlgren & Lance Gardiner                    --
//--  All Rights Reserved.                                                    --
//--                                                                          --
//--  This program is free software; you can redistribute it and/or           --
//--  modify it under the terms of the GNU General Public License             --
//--  as published by the Free Software Foundation; either version            --
//--  2 of the License, or (at your option) any later version.                --
//--  See http://www.gnu.org/licenses/gpl.txt                                 --
//------------------------------------------------------------------------------

#ifndef DIGIO_H
#define DIGIO_H
//==============================================================================

enum { io_OFF = 0, io_INPUT = 1, io_OUTPUT = 2 };
typedef struct {
   UINT08 state;
   SINT16 *result;
} s_digIO;

FAR_PROTO(void digIO_init   (void));
FAR_PROTO(void digInp_enable(UINT08 iPort, SINT16 *result));
FAR_PROTO(void digOut_enable(UINT08 iPort, SINT16 *result));
FAR_PROTO(void digIO_update (void));

//==============================================================================
#endif
