//------------------------------------------------------------------------------
//--  GPIO - General Purpose I/O for CAN-Enabled MegaSquirt                   --
//--                                                                          --
//--  Copyright (c) 2006 by Eric Fahlgren & Lance Gardiner                    --
//--  All Rights Reserved.                                                    --
//--                                                                          --
//--  This program is free software; you can redistribute it and/or           --
//--  modify it under the terms of the GNU General Public License             --
//--  as published by the Free Software Foundation; either version            --
//--  2 of the License, or (at your option) any later version.                --
//--  See http://www.gnu.org/licenses/gpl.txt                                 --
//------------------------------------------------------------------------------

#ifndef EPWM_H
#define EPWM_H
//==============================================================================

typedef struct {
   UINT08 enabled;
   UINT08 isOn;       // Current state
   SINT16 *currentDC; // Duty cycles are in DC*10, 1000 == 100%
   UINT16 period;
   UINT32 nextOn;
   UINT32 nextOff;
} s_ePWM;

FAR_PROTO(void ePWM_init  (void));
FAR_PROTO(void ePWM_enable(UINT08 iPort, UINT16 period, SINT16 *dutycycle));
FAR_PROTO(void ePWM_update(void));

//==============================================================================
#endif
