//------------------------------------------------------------------------------
//--  GPIO - General Purpose I/O for CAN-Enabled MegaSquirt                   --
//--                                                                          --
//--  Copyright (c) 2006 by Eric Fahlgren & Lance Gardiner                    --
//--  All Rights Reserved.                                                    --
//--                                                                          --
//--  This program is free software; you can redistribute it and/or           --
//--  modify it under the terms of the GNU General Public License             --
//--  as published by the Free Software Foundation; either version            --
//--  2 of the License, or (at your option) any later version.                --
//--  See http://www.gnu.org/licenses/gpl.txt                                 --
//------------------------------------------------------------------------------

#ifndef INPUTCAPTURE_H
#define INPUTCAPTURE_H
//==============================================================================

#define N_TIMERS 8

typedef struct {
   UINT08  isEnabled;
   UINT08  mask;
   UINT16  time;
   UINT16  events;
   UINT16  eventInterval;
   UINT08  debounce; // Percentage or tick count?
   UINT32  reenableTime;

   SINT16 *timerOutput;
   UINT16 *countOutput;
} s_inputCapture;

FAR_PROTO(void inputCapture_init    (void));
FAR_PROTO(void inputCapture_enable  (UINT08 iPort, UINT16 p, SINT16 *t, UINT16 *c));
FAR_PROTO(void inputCapture_capture (UINT08 iPort));
FAR_PROTO(void inputCapture_debounce(void));

//==============================================================================
#endif
