//------------------------------------------------------------------------------
//--  GPIO - General Purpose I/O for CAN-Enabled MegaSquirt                   --
//--                                                                          --
//--  Copyright (c) 2006 by Eric Fahlgren & Lance Gardiner                    --
//--  All Rights Reserved.                                                    --
//--                                                                          --
//--  This program is free software; you can redistribute it and/or           --
//--  modify it under the terms of the GNU General Public License             --
//--  as published by the Free Software Foundation; either version            --
//--  2 of the License, or (at your option) any later version.                --
//--  See http://www.gnu.org/licenses/gpl.txt                                 --
//------------------------------------------------------------------------------

#ifndef PWM_H
#define PWM_H
//==============================================================================

#define N_PWMS 6

typedef struct {
   UINT08  enabled;
   SINT16 *currentDC; // Duty cycles are in DC*10, 1000 == 100%
} s_PWM;

FAR_PROTO(void pwm_init   (UINT08 prescaleA, UINT08 scaleA, UINT08 prescaleB, UINT08 scaleB));
FAR_PROTO(void pwm_enable (UINT08 iChannel, UINT08 period, SINT16 *dutyCycle));
FAR_PROTO(void pwm_update (void));

//==============================================================================
#endif
